/*
Codecs.cc
*/

#include "Utils.h"
#include "Codecs.h"

/* For converting 6 bits of data to an 8-bit printable character */
static xuchar encode[64] = {'A', 'B', 'C', 'D', 'E', 'F', 'G',
'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6',
'7', '8', '9', '+', '/'};

/* For converting an 8-bit printable character to 6 bits of data */
static xuchar decode[256] = {
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP,
NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP, NOP};

/* rfc1421encode: Converts standard input containing arbitrary,
 * unsigned bytes into printable characters and writes them
 * to standard output.  A carriage-return/line-feed pair is
 * inserted after every 4 * LINE printed characters. */
// CODIFICA size DEL FICHERO FR Y LO VUELCA A stdout
int EncodeBase64(FILE *FR, int size)
  {
  xuint a, b, c;
  int i, leidos = 0;

  i = 0;
  while (leidos < size)
    {  
    while ((xsint)(a = getc(FR)) != EOF)
    {
      ++leidos;
      if ((xsint)(b = getc(FR)) != EOF)
      {
        ++leidos;
        if ((xsint)(c = getc(FR)) != EOF)
        {
          ++leidos;
          /* Encode three bytes */
          putchar(encode[                  (a >> 2)]);
          putchar(encode[((a & 3) << 4)  + (b >> 4)]);
          putchar(encode[((b & 15) << 2) + (c >> 6)]);
          putchar(encode[((c & 63))]);
          if (++i == LINE)
          {
            putchar('\n');
            i = 0;
          }
        }
        else
        {
          /* Encode last two bytes */
          putchar(encode[                  (a >> 2)]);
          putchar(encode[((a & 3) << 4)  + (b >> 4)]);
          putchar(encode[((b & 15) << 2)           ]);
          putchar('=');
          i++;
          break;
        }
      }
      else
      {
        /* Encode last byte */
        putchar(encode[                  (a >> 2)]);
        putchar(encode[((a & 3) << 4)            ]);
        putchar('=');
        putchar('=');
        i++;
        break;
      }
    }
    if (i != 0) {
      putchar('\n');
    }
    }
  return ERROR_NONE;
}

//IDEM PERO ESCRIBO EN FICHERO QUE YA ESTA ABIERTO PARA ESCRIBIR
int EncodeBase64File (FILE *FR, FILE *FW, int size)
  {
  xuint a, b, c;
  int i, leidos = 0;

  i = 0;
  while (leidos < size)
    {  
    while ((xsint)(a = getc(FR)) != EOF)
    {
      ++leidos;
      if ((xsint)(b = getc(FR)) != EOF)
      {
        ++leidos;
        if ((xsint)(c = getc(FR)) != EOF)
        {
          ++leidos;
          /* Encode three bytes */
          fputc(encode[                  (a >> 2)], FW);
          fputc(encode[((a & 3) << 4)  + (b >> 4)], FW);
          fputc(encode[((b & 15) << 2) + (c >> 6)], FW);
          fputc(encode[((c & 63))], FW);
          if (++i == LINE)
          {
            fputc('\n', FW);
            i = 0;
          }
        }
        else
        {
          /* Encode last two bytes */
          fputc(encode[                  (a >> 2)], FW);
          fputc(encode[((a & 3) << 4)  + (b >> 4)], FW);
          fputc(encode[((b & 15) << 2)           ], FW);
          fputc('=', FW);
          i++;
          break;
        }
      }
      else
      {
        /* Encode last byte */
        fputc(encode[                  (a >> 2)], FW);
        fputc(encode[((a & 3) << 4)            ], FW);
        fputc('=', FW);
        fputc('=', FW);
        i++;
        break;
      }
    }
    if (i != 0) {
      fputc('\n', FW);
    }
    }
  return ERROR_NONE;
}

/* rfc1421decode: Converts standard input containing printable
 * characters into arbitrary, unsigned bytes and writes it to
 * standard output.  Characters of standard input that could not
 * come from standard output of rfc1421encode are ignored. */
// DECODIFICA size DEL FICHERO FR Y LO VUELCA A stdout
int DecodeBase64 (FILE *FR, int size)
  {
  xuint input;           /* Encoded input bytes */
  xuchar a = ' ', b = ' ', c = ' ', d = ' ';     /* Decoded 6-bit input value  */
  int failure = ERROR_NONE;     /* Assume success */
  int leidos = 0;

  if (decode['A'] == NOP) {

    /* We initialize decode in this routine rather than
     * statically because C does not provide a means for
     * statically initializing array elements if the order of
     * the array elements is not known by the programmer.  If we
     * were willing to assume that we were on an ASCII system,
     * we could use static initialization since the order of the
     * characters would then be known. */

    decode['A'] = 0;  decode['B'] = 1;  decode['C'] = 2;  decode['D'] = 3;
    decode['E'] = 4;  decode['F'] = 5;  decode['G'] = 6;  decode['H'] = 7;
    decode['I'] = 8;  decode['J'] = 9;  decode['K'] = 10; decode['L'] = 11;
    decode['M'] = 12; decode['N'] = 13; decode['O'] = 14; decode['P'] = 15;
    decode['Q'] = 16; decode['R'] = 17; decode['S'] = 18; decode['T'] = 19;
    decode['U'] = 20; decode['V'] = 21; decode['W'] = 22; decode['X'] = 23;
    decode['Y'] = 24; decode['Z'] = 25; decode['a'] = 26; decode['b'] = 27;
    decode['c'] = 28; decode['d'] = 29; decode['e'] = 30; decode['f'] = 31;
    decode['g'] = 32; decode['h'] = 33; decode['i'] = 34; decode['j'] = 35;
    decode['k'] = 36; decode['l'] = 37; decode['m'] = 38; decode['n'] = 39;
    decode['o'] = 40; decode['p'] = 41; decode['q'] = 42; decode['r'] = 43;
    decode['s'] = 44; decode['t'] = 45; decode['u'] = 46; decode['v'] = 47;
    decode['w'] = 48; decode['x'] = 49; decode['y'] = 50; decode['z'] = 51;
    decode['0'] = 52; decode['1'] = 53; decode['2'] = 54; decode['3'] = 55;
    decode['4'] = 56; decode['5'] = 57; decode['6'] = 58; decode['7'] = 59;
    decode['8'] = 60; decode['9'] = 61; decode['+'] = 62; decode['/'] = 63;
    /* '=' is a valid character even though it doesn't represent bits.  We'll assign it value EQUAL arbitrarily. */
    decode['='] = EQUAL;
  }

  while (leidos < size)
  {
    while ((xsint)(input = getc(FR)) != EOF && (a = decode[input]) == NOP);
    ++leidos;
    if ((xsint)input != EOF)
    {
      while ((xsint)(input = getc(FR)) != EOF && (b = decode[input]) == NOP);
      ++leidos;
      if ((xsint)input != EOF)
      {
        while ((xsint)(input = getc(FR)) != EOF && (c = decode[input]) == NOP);
        ++leidos;
        if ((xsint)input != EOF)
        {
          while ((xsint)(input = getc(FR)) != EOF && (d = decode[input]) == NOP);
          ++leidos;
          if ((xsint)input != EOF)
          {
            /* Got four significant characters */
            if (a == EQUAL || b == EQUAL || (c == EQUAL && d != EQUAL)) {
              /* If the byte quadruplet has equal signs there
               * must be one or two and they must be the last
               * characters of the quadruplet.*/
              failure = ERROR_EQUAL;
              break;
            }
            if (d != EQUAL)
            {
              /* No '=' padding present */
              putchar((a << 2) + (b >> 4));
              putchar(((b & 15) << 4) + (c >> 2));
              putchar(((c & 3) << 6) + d);
            }
            else if (c != EQUAL)
            {
              /* One '=' padding character present */
              putchar((a << 2) + (b >> 4));
              putchar(((b & 15) << 4) + (c >> 2));
            }
            else if (b != EQUAL)
            {
              /* Two '=' padding characters present */
              putchar((a << 2) + (b >> 4));
            }
          }
          else
          {
            /* Got only three bytes of last BASE64 quadruplet */
            failure = ERROR_INCOMPLETE;
            break;
          }
        }
        else
        {
          /* Got only two bytes of last BASE64 quadruplet */
          failure = ERROR_INCOMPLETE;
          break;
        }
      }
      else
      {
        /* Got only one byte of last BASE64 quadruplet */
        failure = ERROR_INCOMPLETE;
        break;
      }
    }
    else
      {
      /* Reached end of input without error */
      break;
      }
    }
  return failure;
  }

int DecodeQuotedPrintable (FILE *FR, int size)
  {
  const int CNONE = 0;
  const int CIGUAL = 1;
  int i, Estado, sz2, restantes, bleidos, bbleidos, j, contador = 0, cp = 0;
  char ABufferRead[10000], st_out[10], c, stchar[2], *chk;
  
  Estado = CNONE;
  restantes = size;
  strcpy (st_out, "");
  while (restantes > 0)
    {
    if (restantes - 10000 < 0) sz2 = restantes;
    else sz2 = 10000;
    bleidos = fread (ABufferRead, 1, sz2, FR);
    restantes = restantes - bleidos;
    bbleidos = bleidos;
    i = 0;
    while (i < bbleidos)
      { 
      c = ABufferRead[i];
      ++contador;
      /*ESTO ES PARA DEBUG
      if ((cp > 18420) && (cp < 18430)) 
        {fprintf (stderr, "Est:%d NumChRead:%d NumChSav:%d CharRead:%c OrdCharRead:%d\n", 
                  Estado, contador, cp, c, c);}
      */
      switch (Estado)
        {
        case CNONE:                      
          {
          switch (c)
            {
            case '=':  Estado = CIGUAL; strcpy (st_out, ""); break;
            case '\r': printf ("\r\n"); cp += 2; break;
            case '\n': printf ("\r\n"); cp += 2; break;
            default : printf ("%c", c); 
                      ++cp;
                      break;
            }   
          break;
          } //CNONE
        case CIGUAL:
          {            
          switch (c)
            {
            case '=':  printf ("=="); cp += 2; Estado = CNONE; break;
            case '\n': if ((restantes == 0) && (i == bbleidos - 1)) {printf ("=\n"); cp += 2;} 
                       Estado = CNONE; break;
            case '\r': if ((restantes == 0) && (i == bbleidos - 1)) {printf ("=\r"); cp += 2;} 
                       Estado = CNONE; break;            
            default: if (isxdigit (c) == false) 
                       {printf ("=%s%c", st_out, c); strcpy (st_out, ""); Estado = CNONE; break;}
                     stchar[0] = c; stchar[1] = '\0';
                     strcat (st_out, stchar);
                     if (strlen(st_out) == 2)
                       {
                       j = (int)strtol (st_out, &chk, 16);
                       if (*chk != '\0') //BAD INTEGER
                         {
                         printf ("=%s", st_out); strcpy (st_out, ""); Estado = CNONE; break;
                         }      
                       printf ("%c", (char)j); ++cp;
                       Estado = CNONE; 
                       strcpy (st_out, "");
                       }
                     break;
            }             
          break;            
          }
        }  
      ++i;  
      } //while  
    } //WHILE
  return 0;
  }
  
bool IsQuotedPrintable (char *texto)
  {
  int longlinea = 0;
  xuchar c;
  for (int i = 0; (xuint)i < strlen(texto); ++i)
    {
    c = texto[i];
    switch (c)
      {
      case '\r': 
      case '\n':
        if (longlinea > MAXLONGLINEAQUOTEDPRINTABLE) return true;
        longlinea = 0;
        break;
      default: 
        if (c > 126) return true;  
        if (c < 33) return true;  
        ++longlinea; 
        break;
      }
    }
  if (longlinea > MAXLONGLINEAQUOTEDPRINTABLE) return true;  
  return false;
  }  
  
//ESCRIBE EN UN FICHERO TEMPORAL EL STRING DADO (NORMALMENTE
//  EL PRIMER TEXTO DEL MENSAJE) CODIFICANDOLO EN QUOTED
//  PRINTABLE SI ES NECESARIO
//DEVUELVE EL NOMBRE DEL FICHERO TMP GENERADO  
char *ToQuotedPrintableFile (char *texto)
  {
  char *fntmp;
  FILE *FW;
  fntmp = xstrdup (MakeTmpName (NULL)); 
  FW = fopen (fntmp, "w"); 
  if (IsQuotedPrintable (texto) == false)
    {
    fprintf (FW, "%s", texto);
    }  
  else
    {
    xuchar *c;
    xulong len;
    c = ToQuotedPrintableString ((xuchar *)texto, strlen(texto), &len);
    fprintf (FW, "%s", c);
    }
  fclose (FW);
  return fntmp;  
  }
  
void xfs_resize (void **block,size_t size)
  {
  *block = realloc (*block,size ? size : (size_t) 1);
  }

void *xfs_get (size_t size)
  {
  void *block = malloc (size ? size : (size_t) 1);
  return (block);
  }
  
xuchar *ToQuotedPrintableString (xuchar *src, xulong srcl, xulong *len)
  {
  xulong lp = 0;
  xuchar *ret = (xuchar *) xfs_get ((size_t) (3*srcl + (6*srcl)/MAXLONGLINEAQUOTEDPRINTABLE + 3));
  xuchar *d = ret;
  char *hex = "0123456789ABCDEF";
  xuchar c;
  while (srcl--) {              /* for each character */
                                /* true line break? */
    if (((c = *src++) == '\015') && (*src == '\012') && srcl) {
      *d++ = '\015'; *d++ = *src++; srcl--;
      lp = 0;                   /* reset line count */
    }
    else {                      /* not a line break */
                                /* quoting required? */
      if (iscntrl (c) || (c == 0x7f) || (c & 0x80) || (c == '=') ||
          ((c == ' ') && (*src == '\015'))) {
        if ((lp += 3) > MAXLONGLINEAQUOTEDPRINTABLE) { /* yes, would line overflow? */
          *d++ = '='; *d++ = '\015'; *d++ = '\012';
          lp = 3;               /* set line count */
        }
        *d++ = '=';             /* quote character */
        *d++ = hex[c >> 4];     /* high order 4 bits */
        *d++ = hex[c & 0xf];    /* low order 4 bits */
      }
      else {                    /* ordinary character */
        if ((++lp) > MAXLONGLINEAQUOTEDPRINTABLE) {    /* would line overflow? */
          *d++ = '='; *d++ = '\015'; *d++ = '\012';
          lp = 1;               /* set line count */
        }
        *d++ = c;               /* ordinary character */
      }
    }
  }
  *d = '\0';                    /* tie off destination */
  *len = d - ret;               /* calculate true size */
                                /* try to give some space back */
  xfs_resize ((void **) &ret,(size_t) *len + 1);
  return ret;
  } 
  
bool IsThereASCII8bitsInHeaders (xuchar *lin)
  {
  xuint i;
  i = 0;
  while (i < strlen((char *)lin))
    {
    if (int(lin[i]) > 126) {return true;}
    ++i;
    }
  return false;
  }

//From: =?US-ASCII?Q?Keith_Moore?= <moore@cs.utk.edu>
//Subject: =?iso-8859-1?B?4ent8/rg6Ozy+eTre30=?=
char *DecodificaHeader (char *header)
  {
  int L, i;
  char c1, c2, code, letra[2];
  bool quoted;
  XString stresult, stquoted;
  if (strstr (header, "=?") == NULL) {return xstrdup (header);}
  L = strlen (header);
  i = 0; 
  letra[1] = '\0';
  quoted = false;
  stresult = XString("");
  stquoted = XString ("");
  while (i < L)
    {
    c1 = header [i];
    if (i < L - 1) {c2 = header [i + 1];} 
    else c2 = ' ';
    switch (c1)
      {
      case '=': 
        {
        if (quoted == false)
          {
          if (c2 == '?')
            {
            quoted = true; ++i; ++i;
            while (header[i] != '?') {++i;}
            ++i; code = header[i]; ++i; ++i;
            }
          else 
            {
            letra[0] = c1;
            if (quoted) stquoted += letra; 
            else stresult += letra;
            ++i;                  
            }
          }
        else {letra[0] = c1; stquoted += letra; ++i;}
        break;
        }
      case '?': 
        {
        if (c2 == '=')
          {
          switch (code)
            {
            case 'q':
            case 'Q': {
                      XString XS = XString (stquoted);
                      xulong len;
                      stquoted = XString((char *)rfc822_qprint ((xuchar *)stquoted.cstr(),
                                                                strlen((char *)stquoted.cstr()), &len));
                      if (len <= 0) stquoted = XString (XS);
                      break;
                      }
            case 'b':
            case 'B': {
                      XString XS = XString (stquoted);
                      xulong len;
                      stquoted = XString((char *)rfc822_base64 ((xuchar *)stquoted.cstr(), 
                                                                strlen((char *)stquoted.cstr()), &len));
                      if (len <= 0) stquoted = XString (XS);
                      break;
                      }
            default: break;
            }
          stresult +=  stquoted;
          quoted = false;
          stquoted = XString("");
          ++i; ++i;
          }
        else
          {
          letra[0] = c1;
          if (quoted) stquoted += letra; else stresult += letra;
          ++i;
          }
        break;
        }
      default:
        {
        letra[0] = c1;
        if (quoted) stquoted += letra; 
        else stresult += letra;
        ++i;
        break;   
        }
      }
    }
  if (stresult.length() <= 0) {return xstrdup(header);}
  return xstrdup (stresult.cstr());
  }

//From: =?US-ASCII?Q?Keith_Moore?= <moore@cs.utk.edu>
//Subject: =?iso-8859-1?Q?=3F?=
xuchar *CodificaHeaderQuotedP_AllInOne (xuchar *header)
  {
  if (IsThereASCII8bitsInHeaders (header) == false) return header;
  char c;
  xuchar letra[2];
  XString XS;
  xulong len, L;
  letra[1] = '\0';
  XS = XString ("=?US-ASCII?Q?");
  for (L = 0; L < strlen ((char *)header); ++L)
    {
    c = header [L]; 
    letra[0] = c;
    if (int(header[L]) > 126) 
      {
      XS += ((char *)rfc822_8bit(letra, 1, &len));
      }
    else
      {
      XS += (char *)letra;
      }
    }
  XS += "?=";  
  return (xuchar *)xstrdup (XS.cstr());
  }
  
//From: =?US-ASCII?Q?Keith_Moore?= <moore@cs.utk.edu>
//Subject: =?iso-8859-1?Q?=3F?=
xuchar *CodificaHeaderQuotedP_One2One (xuchar *header)
  {
  if (IsThereASCII8bitsInHeaders (header) == false) return header;
  char c;
  xuchar letra[2];
  XString XS;
  xulong len, L;
  letra[1] = '\0';
  XS = XString ("");
  for (L = 0; L < strlen ((char *)header); ++L)
    {
    c = header [L]; 
    letra[0] = c;
    if (int(header[L]) > 126) 
      {
      XS += XString ("=?US-ASCII?Q?");
      XS += ((char *)rfc822_8bit(letra, 1, &len));
      XS += "?=";
      }
    else
      {
      XS += (char *)letra;
      }
    }
  return (xuchar *)xstrdup (XS.cstr());
  }  
  
  
