/*
Config.h
*/

/*
WARNING: If you change any path, you will must
         change accordly Makefile install section.
*/

#ifndef __CONFIG_H
#define __CONFIG_H

#if defined (LINUX)
typedef unsigned char xuchar;
typedef unsigned int xuint;
typedef signed int xsint;
typedef unsigned long xulong;
#elif defined (HP)
#define bool int
#define false  0
#define true   1
typedef int socklen_t;
typedef unsigned char xuchar;
typedef unsigned int xuint;
typedef int xsint;
typedef unsigned long xulong;
#endif

//Web Directory for postman icons, help and html pages.
#define POSTMANDIR "/usr/local/apache/htdocs/postman"

#if (MANT == 0)
#define PROGNAME        "interdaemon"
#define PATH_POSTMAN    "/cgi-bin/postman"
#define HOMEPAGE_SPA    POSTMANDIR"/postman_spa.html"
#define HOMEPAGE_VAL    POSTMANDIR"/postman_val.html"
#define HOMEPAGE_ENG    POSTMANDIR"/postman_eng.html"
#else 
#define PROGNAME          "interdaemon2"
#define PATH_POSTMAN      "/cgi-bin/postman2"
#define HOMEPAGE_SPA      POSTMANDIR"/postman_spa2.html"
#define HOMEPAGE_VAL      POSTMANDIR"/postman_val2.html"
#define HOMEPAGE_ENG      POSTMANDIR"/postman_eng2.html"
#endif

#define MOTD                         "/usr/local/etc/postman.motd"
#define MAILCAP                      "/usr/local/etc/postman.mailcap"
#define FILE_FOR_NO_ACCEPT_NEW_CONNS "/usr/local/etc/postman.disabled"

//WARNINGS: DO NO PUT SLASH AT THE END OF THE PATHS!
//          DIRECTORIES MUST BE EXISTS!

#define BASEDIR             "/var/postman"
#define UNIX_SOCKETS_PATH   BASEDIR"/server"
#define PIDDIR              BASEDIR"/server"
#define SOCK_SESSIONS_PATH  BASEDIR"/sessions"
#define LOCKSDIR            BASEDIR"/locks"
#define TMP                 BASEDIR"/tmp"
#define UMASK               077
#define USERDIRMODE         0710
#define USERATTACHSDIRMODE  0770
#define CONVERTUSERNAMETOLOWERCASE 1

//1 Allow several connections from the same user using that program, 0 only one
#define ALLOW_SEVERAL_CONNS 0

//in seconds, read in lock file.
#define MAX_TIME_BETWEEN_CONNS 10

//in bytes
#define SOCKETSIZE 4096

//***** DEFAULT OPTIONS ********************
#define DEFOPT_INSERTSIGNATUREINNEWMSG false
//0 display all msgs in one page
#define DEFOPT_MSGSPERINDEXPAGE        10
#define DEFOPT_SAVEMSGSENTMAIL         false
#define DEFOPT_WIDTHWRITEAREA          70
#define DEFOPT_HEIGHTWRITEAREA         30
#define DEFOPT_REPLYFROM               false
#define DEFOPT_FORW_ATTACHS            true
#define DEFSENTMAILBOX                 "sent-mail"
#define MAXNUMATTACHSINSEND            30
//(in bytes)
#define MAXTEXTSIZEATTACHFORDISPLAY    10000

//***** WWW ABSOLUTE DIRECTORIES ************************
#define PATH_IMAGENS      "/postman/icons"

//***** DB CONF *****************************************
#define USEDBFORCONF 0
#define DBFILE "/u/www/protect/passwd_u.db"

//***** MISC ********************************************
#define DEFIMAPPORT 143
#define DEFSMTPPORT 25
#define USETIMEOUT 1
#define CONFIRM_DELETEMAILBOX 1
#define CONFIRM_EXPUNGE       1     
#define CONFIRM_LOGOUT        1
#define SIGNATURENAME   ".signature"
#define USEROPTIONSNAME ".options"
#define USERADDRESSBOOKNAME ".addressbook"
#define SAVEDINCOMPOSE ".savedmsg"
#define BGTABLECOLOR "#CCCCCC"
#define TABLEFACEFONT "PrimaSans BT,Verdana,sans-serif"
#define MAINFACEFONT "PrimaSans BT,Verdana,sans-serif"
#define MAINSIZEFONT 2
#define STATUSFACEFONT "PrimaSans BT,Verdana,sans-serif"
#define MAINCOLORFONT "#000000"
#define LENGTHBOUNDARY 50
#define XMAILER "postman 1.0"
//#define THECHARSET "US-ASCII"
#define THECHARSET "ISO-8859-1"
#define CUTINDICATOR "..."
#define USELETTERSINFLAGS 0
#define CALCULATEMAILBOXSIZE 1
#define DISPLAYTXTATTASHTML 0

//in bytes
#define MAXLENGTH_IN_REPLY 50000
#define MAXLENGTH_IN_SIGN  1000
#define MAXLENGTH_FIELD_AB 300
#define MAXLENGTH_TO       1000
#define MAXLONGATT         5000000
#define UNHANDLESIZEATTACH 30000000


#define REPLY_BEGIN_LINE "> "

//***** IMAGES ******************************************
//#define IMG_BACKGROUND PATH_IMAGENS"/fondo2.jpg"
#define IMG_BACKGROUND PATH_IMAGENS"/background.jpg"
//#define IMG_BACKGROUND PATH_IMAGENS"/fons1.gif"
//#define IMG_BACKGROUND PATH_IMAGENS"/"
#define IMG_LOGO PATH_IMAGENS"/logo.gif"
#define IMG_FLAG_DELETED   PATH_IMAGENS"/flag_deleted.gif"
#define IMG_FLAG_ANSWERED  PATH_IMAGENS"/flag_answered.gif"
#define IMG_FLAG_FLAGGED   PATH_IMAGENS"/flag_flagged.gif"
#define IMG_FLAG_UNSEEN    PATH_IMAGENS"/flag_unseen.gif"
#define TXTCOLOR "#000000"
#define BGCOLOR  "#FFFFFF"

//*************** IMAP    *****
#define IMAPPATHTOMAILBOXES "~/mail/"

//***************  LOG ****
#define XLOGFACILITY LOG_MAIL
#define XLOGOPTIONS  LOG_PID
#define XLOGPRIORITY LOG_INFO

//****************  DISPLAY EN INDEX
#define LONGDISPLAYSUBJECT 35
#define LONGDISPLAYFROM    20
#define LONGDISPLAYDATE     6

//****************    HELP PAGES
#define HELP_ENG_LOGIN          "/postman/help/login_eng.html"
#define HELP_SPA_LOGIN          "/postman/help/login_spa.html"
#define HELP_VAL_LOGIN          "/postman/help/login_val.html"
#define HELP_ENG_INDEXMAILBOX   "/postman/help/indexmailbox_eng.html"
#define HELP_SPA_INDEXMAILBOX   "/postman/help/indexmailbox_spa.html"
#define HELP_VAL_INDEXMAILBOX   "/postman/help/indexmailbox_val.html"
#define HELP_ENG_DISPLAYMESSAGE "/postman/help/displaymessage_eng.html"
#define HELP_SPA_DISPLAYMESSAGE "/postman/help/displaymessage_spa.html"
#define HELP_VAL_DISPLAYMESSAGE "/postman/help/displaymessage_val.html"
#define HELP_ENG_SHOWMAILBOXES  "/postman/help/showmailboxes_eng.html"
#define HELP_SPA_SHOWMAILBOXES  "/postman/help/showmailboxes_spa.html"
#define HELP_VAL_SHOWMAILBOXES  "/postman/help/showmailboxes_val.html"
#define HELP_ENG_COMPOSEMSG     "/postman/help/composemsg_eng.html"
#define HELP_SPA_COMPOSEMSG     "/postman/help/composemsg_spa.html"
#define HELP_VAL_COMPOSEMSG     "/postman/help/composemsg_val.html"
#define HELP_ENG_SHOWOPTIONS    "/postman/help/showoptions_eng.html"
#define HELP_SPA_SHOWOPTIONS    "/postman/help/showoptions_spa.html"
#define HELP_VAL_SHOWOPTIONS    "/postman/help/showoptions_val.html"
#define HELP_ENG_ADDBOOK        "/postman/help/addbook_eng.html"
#define HELP_SPA_ADDBOOK        "/postman/help/addbook_spa.html"
#define HELP_VAL_ADDBOOK        "/postman/help/addbook_val.html"
#define HELP_ENG_SHOWATTACHS    "/postman/help/showattachs_eng.html"
#define HELP_SPA_SHOWATTACHS    "/postman/help/showattachs_spa.html"
#define HELP_VAL_SHOWATTACHS    "/postman/help/showattachs_val.html"
#define HELP_ENG_ABOUT          "/postman/help/about.html"
#define HELP_SPA_ABOUT          "/postman/help/about.html"
#define HELP_VAL_ABOUT          "/postman/help/about.html"                                                    
#define HELP_ENG_AB_NEWENTRY    "/postman/help/editaddbook_eng.html"
#define HELP_SPA_AB_NEWENTRY    "/postman/help/editaddbook_spa.html"
#define HELP_VAL_AB_NEWENTRY    "/postman/help/editaddbook_val.html"                                                    
#define HELP_ENG_AB_EDITENTRY   "/postman/help/editaddbook_eng.html"
#define HELP_SPA_AB_EDITENTRY   "/postman/help/editaddbook_spa.html"
#define HELP_VAL_AB_EDITENTRY   "/postman/help/editaddbook_val.html"                                                    

                    
//***************    OTHER PAGES
#define SERVER_IS_DISABLED      "/postman/disabled.html"

#endif





