/*
Configuration.cc
*/

#include "Configuration.h"

Configuration::Configuration (bool aAbortInError)
  {
  AbortInError = aAbortInError;
  //WARNING WITH MAXPARAMETERS
  CfgInfo[0].name = "imapserver";     CfgInfo[0].data = NULL;
  CfgInfo[1].name = "imapport";       CfgInfo[1].data = NULL;
  CfgInfo[2].name = "smtpserver";     CfgInfo[2].data = NULL;
  CfgInfo[3].name = "usersbasepath";  CfgInfo[3].data = NULL;
  CfgInfo[4].name = "maildomain";     CfgInfo[4].data = NULL;
  CfgInfo[5].name = "maxconnallowed"; CfgInfo[5].data = NULL;  
  CfgInfo[6].name = "timeout";        CfgInfo[6].data = NULL;  
  CfgInfo[7].name = NULL;             CfgInfo[7].data = NULL;
  }
  
Configuration::~Configuration ()
  {
  }
  
bool Configuration::setConfiguration (char *afnconf)
  {
  if (!FileExists (afnconf)) return false;
  fnconf = XString (afnconf);
  return ConfRead ();
  }  
  
bool Configuration::reload (void)
  {
  return ConfRead ();
  }    
  
void Configuration::Error (void)
  {
  printf ("Error reading configuration file \"%s\"! Aborting ...\n", (char *)fnconf.cstr()); 
  if (AbortInError == true) {exit (1);}
  }  
  
const char *Configuration::getParm (char *aname)
  {
  int i;
  i = 0;
  while ((i < MAXPARAMETERS) && (CfgInfo[i].name != NULL))
    {
    if (strcmp (aname, CfgInfo[i].name) == 0) return CfgInfo[i].data;
    ++i;
    }
  return "";  
  }
                                  
int Configuration::getIParm (char *aname, int defvalue)
  {
  int i;
  i = 0;
  while ((i < MAXPARAMETERS) && (CfgInfo[i].name != NULL))
    {
    if (strcmp (aname, CfgInfo[i].name) == 0) 
      return xatoidef (CfgInfo[i].data, defvalue);
    ++i;
    }
  return defvalue;  
  }

bool Configuration::ConfRead (void)
  {
  char Buffer[XBUFFERSIZE], *WorkPtr, *CfgName, *CfgData;
  FILE *CfgFile;
  TCfgStrings *cfg;

  CfgFile = fopen ((char *)fnconf.cstr(), "r");
  if (NULL == CfgFile ) {Error(); return false;}

  while (NULL != fgets( Buffer, XBUFFERSIZE, CfgFile))
    {
    if( NULL != (WorkPtr = strchr( Buffer, ';' ))) *WorkPtr = '\0';
    else WorkPtr = Buffer + strlen( Buffer );

    WorkPtr--;
    while (isspace( *WorkPtr ) && WorkPtr >= Buffer ) *WorkPtr-- = '\0';
    WorkPtr = Buffer;
    while (isspace( *WorkPtr )) WorkPtr++;
    if( 0 == strlen( WorkPtr )) continue;
    CfgName = strtok (WorkPtr, " =" );
    if( NULL != CfgName )
      {
      CfgName = xlcase (CfgName);
      CfgData = strtok( NULL, "" );
      while (isspace( *CfgData )) {CfgData++;}
      if ('=' == *CfgData) CfgData++;
      while (isspace( *CfgData )) {CfgData++;}

      cfg = CfgInfo;
      while ((NULL != cfg->name) && (0 != strcmp(cfg->name, CfgName))) {cfg++;}
      if (NULL != cfg->name )
        {
        cfg->data = strdup (CfgData);
        if (NULL == cfg->data)
          {
          fclose( CfgFile );
          Error(); 
          return false;
          }
        }
      }
    }
  fclose (CfgFile);
  return true;
  }
  
  
  
  
  
  
  
  
