/*
Configuration.h
*/

#ifndef __CONFIGURATION_H
#define __CONFIGURATION_H

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>

#include "Utils.h"
#include "Config.h"
#include "XString.h"

struct TCfgStrings
  {
  char *name;
  char *data;
  };
  
const int MAXPARAMETERS = 15;
const int XLINE_LEN_MAX = 128;
const int XBUFFERSIZE   = XLINE_LEN_MAX + 2;

class Configuration
  {
  private:
    TCfgStrings CfgInfo[MAXPARAMETERS];
    XString fnconf;
    bool AbortInError;
    void Error (void);
  public:
    Configuration (bool aAbortInError);
    virtual ~Configuration (); 
    bool setConfiguration (char *afnconf);    
    bool ConfRead (void);
    const char *getParm (char *name);
    int getIParm (char *aname, int defvalue);
    bool reload (void);    
  };
  
#endif


