/*
Language.h
*/

#ifndef __LANGUAGE_H
#define __LANGUAGE_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Utils.h"

#define CMAXLONGLANGUAGE 20

#define LANG_ENGLISH 0
#define LANG_SPANISH 1
#define LANG_CATALA  2
#define MAX_LANG     2
#define LANG_DEFAULT LANG_SPANISH

class Language 
  {
  private:
    int LANGUAGE;
    char stLANGUAGE[CMAXLONGLANGUAGE + 1];
    char *getStringEnglish (int WHAT);
    char *getStringSpanish (int WHAT);    
    char *getStringCatala  (int WHAT);        
    char *getImageEnglish (int WHAT);
    char *getImageSpanish (int WHAT);    
    char *getImageCatala  (int WHAT);            
    char *getPageEnglish (int WHAT);
    char *getPageSpanish (int WHAT);    
    char *getPageCatala  (int WHAT);            
  public:
    Language (int aLANGUAGE);
    Language (char *pcLANGUAGE); 
    virtual ~Language();
    void setLang (int aLANGUAGE);
    int getLang ();    
    char *get  (int WHAT);   
    char *getI (int WHAT); 
    char *getPage (int WHAT);
  };

#define MSG_CONNREFUSED        1
#define MSG_CANRECONNECTHERE   2
#define MSG_SERVERISDOWN       3
#define MSG_PERHAPSTIMEOUT     4
#define MSG_CONF_DELETEMAILBOX 5
#define MSG_CONF_EXPUNGE       6
#define MSG_CONF_LOGOUT        7
#define MSG_SEND_OK            8
#define MSG_SEND_ERR           9
#define MSG_CANCELMSG         14
#define MSG_SHOWOPTIONS       15
#define MSG_SAVEOPTIONS       16
#define MSG_CANCELOPTIONS     17
#define MSG_ADDBOOK           18
#define MSG_SAVEADDBOOK       19
#define MSG_ERR_SAVEOPTIONS   21
#define MSG_ERR_SAVEADDBOOK   22
#define MSG_MSGSPURGED        23
#define MSG_MSGSPURGED_S      24
#define MSG_MSGSPURGED_0      25
#define MSG_MAILBOXCHANGED    26
#define MSG_MAILBOXCREATED    27
#define MSG_MAILBOXDELETED    28
#define MSG_MAILBOXRENAMED    29
#define MSG_MOVEDMESSAGES     30
#define MSG_MOVEDMESSAGES_S   31
#define MSG_COPYMESSAGES      32
#define MSG_COPYMESSAGES_S    33
#define MSG_INVALIDPAGE       34
#define MSG_SHOWATTACHS       35
#define MSG_SAVEATTACHS       36
#define MSG_ERASEATTACHS      37
#define MSG_ERR_SAVEATTACHS   38
#define MSG_AB_EDITENTRY      39
#define MSG_AB_SAVEENTRY      40
#define MSG_AB_DELEENTRY      41
#define MSG_AB_ADDTO          42
#define MSG_AB_ADDCC          43
#define MSG_AB_ADDBCC         44            
#define MSG_NO_MSGS_MARKED    45
#define MSG_FLAGS_CHANGED     46
#define MSG_FLAGS_CHANGED_S   47
#define MSG_FIELD_TO_EMPTY    48
#define MSG_FIELD_SUBJ_EMPTY  49      
#define MSG_COMPOSE_TIMEOUT   50
#define MSG_TOO_MAX_CONN      51
#define MSG_ERR_SAVE_SENTMAIL 52
#define MSG_TOO_MAX_TRY_CONN  53
#define MSG_ADDRESS_LINE_CUT  54
#define MSG_MIN_TIMEBETWCONNS 55
#define MSG_ERR_RELOAD_ATTACHS 56
#define MSG_NOATTACHSERASED   57
#define MSG_NOATTACHSSAVED    58

#define L_ATTACHSHOWED     100
#define L_USER             101
#define L_PASSWORD         102 
#define L_LOGIN            103
#define L_CLEAR            104
#define L_LOGOUT           105
#define L_INDEXMAILBOX     106
#define L_CHOOSELANGUAGE   107
#define L_COPYRIGHT        108
#define L_MESSAGES         109
#define L_PREVPAGE_ACT     110
#define L_PREVPAGE_INA     111
#define L_NEXTPAGE_ACT     112
#define L_NEXTPAGE_INA     113
#define L_FIRSTPAGE_ACT    114
#define L_FIRSTPAGE_INA    115
#define L_LASTPAGE_ACT     116
#define L_LASTPAGE_INA     117
#define L_MESSAGE          118
#define L_INDEXMAILBOX2    119
#define L_MESSAGE2         120
#define L_DUMPMSG          121
#define L_NOSUBJECT        122
#define L_NEXTMSG          123
#define L_NEXTMSG_INA      124
#define L_PREVMSG          125
#define L_PREVMSG_INA      126
#define L_ERROR            127
#define L_STRUCTMIME       128
#define L_EXECUTE          129
#define L_DELETEMSG        130
#define L_EXPUNGE          131
#define L_UNDELETEMSG      132
#define L_HELP             133
#define L_COMPOSEMSG       134
#define L_MAILBOXES        135
#define L_CHANGEMAILBOX    136
#define L_CREATEMAILBOX    137
#define L_DELETEMAILBOX    138
#define L_RENAMEMAILBOX    139
#define L_ANSWEREDMSG      140
#define L_UNANSWEREDMSG    141
#define L_FLAGGEDMSG       142
#define L_UNFLAGGEDMSG     143
#define L_SEENMSG          144
#define L_UNSEENMSG        145
#define L_RECENTMSG        146
#define L_UNRECENTMSG      147
#define L_MOVEMSG          148
#define L_COPYMSG          149
#define L_CANCEL           150
#define L_CONFIRM          151
#define L_TO               152
#define L_CC               153
#define L_BCC              154
#define L_SUBJECT          155
#define L_TEXTTOSEND       156
#define L_CANCELMSG        157
#define L_SENDMSG          158
#define L_ATTACHMSG        159
#define L_REPLYMSG         160
#define L_FORWARDMSG       161
#define L_FROM             162
#define L_DATE             163
#define L_REPLYTO          164
#define L_SHOWOPTIONS      166
#define L_ADDBOOK          167
#define L_SAVE             168
#define L_MSGSPERINDEXPAGE 169
#define L_INSIGNINNEWMSG   170
#define L_PERSONALNAME     171
#define L_NOFROM           172
#define L_SIGNATURE        173
#define L_SAVEMSGSENTMAIL  174
#define L_ATTACH_NEW       175
#define L_FILE             176
#define L_NO_ATTACHS       177
#define L_DOATTACH         178
#define L_DETACH           179
#define L_AB_NICKNAME      180
#define L_AB_FULLNAME      181
#define L_AB_ADDRESSES     182
#define L_AB_FCC           183
#define L_AB_COMMENTS      184
#define L_AB_EDITENTRY     185
#define L_AB_NEWENTRY      186
#define L_DELETE           187
#define L_NUMOFENTRIES     188
#define L_BACK             189
#define L_CLEANALL         190
#define L_SAVEADDRESS      191
#define L_NUMBER           192
#define L_FLAGS            193
#define L_SIZE             194
#define L_FLAG_DELETED     195
#define L_FLAG_ANSWERED    196
#define L_FLAG_FLAGGED     197
#define L_FLAG_NEW         198
#define L_FLAG_UNSEEN      199
#define L_MARK             200
#define L_MSGS_AS          201
#define L_PRESS_TO_INDEX   202
#define L_EDIT             203
#define L_SORT             204
#define L_MSGS_SHOWN       205
#define L_INDEXMAILBOX3    206
#define L_LEX_TO           207
#define L_DELNEXTMSG       208
#define L_ABOUT            209
#define L_REPLYFROM        210
#define L_FORWATTACHS      211
#define L_SIZEWRITEAREA    212
#define L_UNDELNEXTMSG     213
#define L_NEXTMSGSHOWN     214
#define L_LASTMSGSHOWN     215
#define L_NUMATTACHSHOW    216
#define L_INDEXMAILBOX4    217
#define L_DOWNLOADMAILBOX  218

#define ERR_INV_CMD              300
#define ERR_INV_USER_PW          301
#define ERR_INV_MAILBOX          302
#define ERR_INV_PARMS            303
#define ERR_OPENCONN             304
#define ERR_CREAT_USERDIR        305
#define ERR_CREAT_USERATTACHSDIR 306
#define ERR_SENDING_MSG          307    
#define ERR_AB_DELEENTRY         308
#define ERR_MAXSIZEATT           309
#define ERR_UNHANDLESIZEATTACH   310

#define ALT_LOGO           500
#define ALT_PREVPAGE_ACT   501
#define ALT_PREVPAGE_INA   502
#define ALT_NEXTPAGE_ACT   503
#define ALT_NEXTPAGE_INA   504
#define ALT_FIRSTPAGE_ACT  505
#define ALT_FIRSTPAGE_INA  506
#define ALT_LASTPAGE_ACT   507
#define ALT_LASTPAGE_INA   508
#define ALT_DUMPMSG        509
#define ALT_NEXTMSG        510
#define ALT_PREVMSG        511
#define ALT_NEXTMSG_INA    512
#define ALT_PREVMSG_INA    513
#define ALT_LOGOUT         514
#define ALT_EXPUNGE        515
#define ALT_HELP           516
#define ALT_COMPOSEMSG     517
#define ALT_MAILBOXES      518
#define ALT_REPLYMSG       519
#define ALT_FORWARDMSG     520
#define ALT_SHOWOPTIONS    522
#define ALT_ADDBOOK        523
#define ALT_BACK           524
#define ALT_SAVEADDRESS    525
#define ALT_SORT           526
#define ALT_AB_NEWENTRY    527
#define ALT_DELNEXTMSG     528
#define ALT_ABOUT          529
#define ALT_UNDELNEXTMSG   530

#define FLAG_RECENT        700
#define FLAG_NEW           701
#define FLAG_UNSEEN        702
#define FLAG_FLAGGED       703
#define FLAG_ANSWERED      704
#define FLAG_DELETED       705
#define FLAG_EMPTY         706

#define TIT_COMPOSEMSG     900
#define TIT_HOMEPAGE       901
#define TIT_CONFIRMACTION  902
#define TIT_INDEXMAILBOX   903
#define TIT_MAILBOXES      904
#define TIT_MESSAGEHEADER  905 
#define TIT_REPLYMSG       906
#define TIT_FORWARDMSG     907
#define TIT_SHOWOPTIONS    909
#define TIT_ADDBOOK        910
#define TIT_INVALIDPAGE    911
#define TIT_SHOWATTACHS    912

#define PREFIX_REPLY       1100
#define PREFIX_FORWARD     1101

#define FORWARDLINE        1300

#endif











