/*
Postman.cc
*/

/* ====================================================================
 * Copyright (c) 2000 University of Valencia.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the University 
 *    of Valencia."
 *
 * 4. The names "Postman" must not be used to endorse or promote products 
 *    derived from this software without prior written permission.
 *
 * 5. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the University of Valencia"
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 */

#include "Postman.h"

Language *L;

int main (void)
  {
  char *stcmd, *stsubcmd, *stlang, *connid, *user, *pw, *parm1, *parm2, 
       *parm3, *parm4, *mulmsgs, *theaction2, *attnumbers;
  int CodeUpload, cmd, sock, res, validator, pageid, lastcmd;
  TBuffer BufW, BufR;
  TSBuffer fnsocket, clientip;
  XSocket *clientsocket;
  CGI *cgi;
  long len;

  openlog (PROGNAME, XLOGOPTIONS, XLOGFACILITY);
  Randomize ();
  cgi= new CGI (BASEDIR);
  CodeUpload = cgi->getCodeUpload();
    
  stcmd    = cgi->getCmd ();
  stsubcmd = cgi->getSubCmd ();
  stlang   = cgi->getLang();
  connid   = cgi->getConnid();
  validator= xatoidef(cgi->getValidator(), 0);
  pageid   = xatoidef(cgi->getPageId(), -1);
  lastcmd  = xatoidef(cgi->getLastCmd(), -1); 
  user     = cgi->getUser();
  parm1    = cgi->getParm1();
  parm2    = cgi->getParm2();
  parm3    = cgi->getParm3();
  parm4    = cgi->getParm4();
  strcpy (clientip, cgi->get_REMOTE_ADDR ("-"));
  
  clientsocket = new XSocket ();
  L = new Language (stlang);
    
  if (CodeUpload == -100)
    {
    TSBuffer abuf;
    sprintf (abuf,  L->get(ERR_MAXSIZEATT), MAXLONGATT);
    ErrorPage (abuf);
    fclose (stdout);
    exit (0);
    }    
    
  theaction2 = cgi->GetEntryDef ("theaction2", "");
  if (!IsEmpty (theaction2)) {stcmd = cgi->GetEntryDef ("cmd2", "");}
  cmd = TranslateCmd (stcmd);  
  
  switch (cmd)
    {
    //connid=-1 validator=-1 lang home
    case (CMD_HOME): 
      PrintHomePage(stlang);
      break;
    //connid=-1 validator=-1 lang help
    case (CMD_HELP):
      PrintHelpPage (stsubcmd);
      break;      
    //connid=-1 validator=-1 pageid=-1 lastcmd=-1 lang login user pw  
    case (CMD_LOGIN):   
      if (FileExists (FILE_FOR_NO_ACCEPT_NEW_CONNS) == true)
        {
        Redirect (SERVER_IS_DISABLED);
        exit (0);
        break;
        }
      strcpy(fnsocket, make_root_socket());
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      pw = cgi->GetEntryDef ("pw", "");
      sprintf (BufW, "-1 -1 -1 -1 %s %s login %s %s\n", stlang, clientip, user, pw);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;  
    //connid validator lang logout
    case (CMD_LOGOUT): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      sprintf (BufW, "%s %d %d %d %s %s logout\n", connid, pageid, validator, lastcmd, stlang, clientip);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);} 
      break;
    //connid validator lang mg_dump nummsg  
    case (CMD_MG_DUMP): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);
      sprintf (BufW, "%s %d %d %d %s %s mg_dump %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
    //connid validator lang mg_display nummsg  
    case (CMD_MG_DISPLAY): 
      {
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);
      sprintf (BufW, "%s %d %d %d %s %s mg_display %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
      }
    //connid validator lang mg_deldisplay nummsg  
    case (CMD_MG_DELDISPLAY): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);
      sprintf (BufW, "%s %d %d %d %s %s mg_deldisplay %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);} 
      break;      
    //connid validator lang mg_undeldisplay nummsg  
    case (CMD_MG_UNDELDISPLAY): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);
      sprintf (BufW, "%s %d %d %d %s %s mg_undeldisplay %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);} 
      break;            
    //connid validator lang mg_move nummsg1 nummsg2 ...
    case CMD_MG_MOVE:
      parm1 = cgi->GetEntryDef ("mailboxname", "INBOX");
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      mulmsgs = cgi->GetMultipleEntries ("msgnumber", ",");
      sprintf (BufW, "%s %d %d %d %s %s mg_move %s %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1, mulmsgs);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break; 
    //connid validator lang mg_copy nummsg1 nummsg2 ...
    case CMD_MG_COPY:
      parm1 = cgi->GetEntryDef ("mailboxname", "INBOX");
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      mulmsgs = cgi->GetMultipleEntries ("msgnumber", ",");
      sprintf (BufW, "%s %d %d %d %s %s mg_copy %s %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1, mulmsgs);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
    //connid validator lang at_dump nummsg attid codec contenttype
    case (CMD_AT_DUMP): 
      {
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);
      int codec; codec = xatoidef (parm3, (int)0);
      sprintf (BufW, "%s %d %d %d %s %s at_dump %ld %s %d %s\n", connid, pageid, validator, lastcmd, stlang, clientip, len, parm2, codec, parm4);
      res = clientsocket->Puts (BufW);
      int alen;
      while ((alen = clientsocket->Read (BufR, CMAXBUFFER)) != ERROR_SOCKET)
        {write (fileno(stdout), BufR, alen);}
      break;
      }
    //connid validator lang mb_index beginmsg  
    case (CMD_MB_INDEX):
      { 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);
      sprintf (BufW, "%s %d %d %d %s %s mb_index %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
      }
    //connid validator lang mb_show
    case (CMD_MB_SHOW): 
      {
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      sprintf (BufW, "%s %d %d %d %s %s mb_show\n", connid, pageid, validator, lastcmd, stlang, clientip);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
      }  
    //connid validator lang mb_change mailboxname
    case (CMD_MB_CHANGE): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      parm1 = cgi->GetEntryDef ("mailboxname", "INBOX");
      sprintf (BufW, "%s %d %d %d %s %s mb_change %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;               
    //connid validator lang mb_create mailboxname
    case (CMD_MB_CREATE): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      parm1 = cgi->GetEntryDef ("mailboxname", "");
      sprintf (BufW, "%s %d %d %d %s %s mb_create %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
    //connid validator lang mb_delete mailboxname
    case (CMD_MB_DELETE): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      parm1 = cgi->GetEntryDef ("mailboxname", "");
      sprintf (BufW, "%s %d %d %d %s %s mb_delete %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;      
    //connid validator lang mb_rename oldmailboxname newmailboxname
    case (CMD_MB_RENAME): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      parm1 = cgi->GetEntryDef ("oldmailboxname", "");
      parm2 = cgi->GetEntryDef ("newmailboxname", "");
      sprintf (BufW, "%s %d %d %d %s %s mb_rename %s %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1, parm2);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
    //connid validator lang mb_expunge
    case (CMD_MB_EXPUNGE): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      sprintf (BufW, "%s %d %d %d %s %s mb_expunge\n", connid, pageid, validator, lastcmd, stlang, clientip);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);} 
      break;
    //connid validator lang mb_dump
    case (CMD_MB_DUMP): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      sprintf (BufW, "%s %d %d %d %s %s mb_dump\n", connid, pageid, validator, lastcmd, stlang, clientip);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
    //FLAGS
    //connid validator lang flagscmd nummsg1 nummsg2 ...
    case CMD_FG_DELETE: 
    case CMD_FG_UNDELETE:
    case CMD_FG_ANSWERED:
    case CMD_FG_UNANSWERED:
    case CMD_FG_FLAGGED:
    case CMD_FG_UNFLAGGED:
    case CMD_FG_SEEN:
    case CMD_FG_UNSEEN:
    case CMD_FG_RECENT:
    case CMD_FG_UNRECENT: 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      mulmsgs = cgi->GetMultipleEntries ("msgnumber", ",");
      switch (cmd)
        {
        case CMD_FG_DELETE:     sprintf (BufW, "%s %d %d %d %s %s fg_delete %s\n",    connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_UNDELETE:   sprintf (BufW, "%s %d %d %d %s %s fg_undelete %s\n",  connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_ANSWERED:   sprintf (BufW, "%s %d %d %d %s %s fg_answered %s\n",  connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_UNANSWERED: sprintf (BufW, "%s %d %d %d %s %s fg_unanswered %s\n",connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_FLAGGED:    sprintf (BufW, "%s %d %d %d %s %s fg_flagged %s\n",   connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_UNFLAGGED:  sprintf (BufW, "%s %d %d %d %s %s fg_unflagged %s\n", connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_SEEN:       sprintf (BufW, "%s %d %d %d %s %s fg_seen %s\n",      connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_UNSEEN:     sprintf (BufW, "%s %d %d %d %s %s fg_unseen %s\n",    connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_RECENT:     sprintf (BufW, "%s %d %d %d %s %s fg_recent %s\n",    connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        case CMD_FG_UNRECENT:   sprintf (BufW, "%s %d %d %d %s %s fg_unrecent %s\n",  connid, pageid, validator, lastcmd, stlang, clientip, mulmsgs); break;
        }
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
    //connid lang conf_act subcmd ...
    //se confirman los comandos: CMD_DELETEMAILBOX, CMD_LOGOUT, CMD_EXPUNGE
    case CMD_CONF_ACT:
      {
      parm2 = cgi->GetEntryDef ("mailboxname", "");
      int subcmd;
      subcmd = TranslateCmd (stsubcmd);
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      switch (subcmd)
        {
        case CMD_MB_DELETE: 
          sprintf (BufW, "%s %d %d %d %s %s conf_act mb_delete %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm2);
          break;
        case CMD_LOGOUT:
          sprintf (BufW, "%s %d %d %d %s %s conf_act logout\n", connid, pageid, validator, lastcmd, stlang, clientip);
          break;                          
        case CMD_MB_EXPUNGE:
          sprintf (BufW, "%s %d %d %d %s %s conf_act mb_expunge\n", connid, pageid, validator, lastcmd, stlang, clientip);
          break;  
        }  
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
      }
    //connid validator lang cm
    case CMD_CM:
      if ((!IsEmpty (cgi->GetEntryDef ("cm_send", ""))) && (IsEmpty (cgi->GetEntryDef ("to", ""))))
        {ErrorPage (L->get(ERR_INV_PARMS)); clientsocket->Close (); exit (0);}
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);      
      if (!IsEmpty (cgi->GetEntryDef ("cm_cancel", "")))
        {
        sprintf (BufW, "%s %d %d %d %s %s cm_cancel\n", connid, pageid, validator, lastcmd, stlang, clientip);
        }
      else if (!IsEmpty (cgi->GetEntryDef ("cm_save", "")))
        {
        TBuffer fntmp;
        FILE *fw;
        MakeTmpName (fntmp);
        fw = fopen (fntmp, "w");
        fprintf (fw, "%s\n", cgi->GetEntryDef ("savemsgsentmail", "0"));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("to", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("cc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("bcc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("subject", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("texttosend", ""));
        fclose (fw);        
        sprintf (BufW, "%s %d %d %d %s %s cm_save %s\n", connid, pageid, validator, lastcmd, stlang, clientip, fntmp);
        }
      else if (!IsEmpty (cgi->GetEntryDef ("ab_from_cm", "")))
        {
        TBuffer fntmp;
        FILE *fw;
        MakeTmpName (fntmp);
        fw = fopen (fntmp, "w");
        fprintf (fw, "%s\n", cgi->GetEntryDef ("savemsgsentmail", "0"));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("to", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("cc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("bcc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("subject", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("texttosend", ""));
        fclose (fw);        
        sprintf (BufW, "%s %d %d %d %s %s ab_from_cm %s\n", connid, pageid, validator, lastcmd, stlang, clientip, fntmp);        
        }                                
      else if (!IsEmpty (cgi->GetEntryDef ("cm_send", "")))
        {
        int numattachs;
        numattachs = xatoidef (cgi->GetEntryDef ("numattachs", "0"), 0);
        TBuffer fntmp;
        FILE *fw;
        MakeTmpName (fntmp);
        fw = fopen (fntmp, "w");
        fprintf (fw, "%s\n", cgi->GetEntryDef ("savemsgsentmail", "0"));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("to", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("cc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("bcc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("subject", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("texttosend", ""));
        fclose (fw);
        sprintf (BufW, "%s %d %d %d %s %s cm_send %s %d\n", connid, pageid, validator, lastcmd, stlang, clientip, fntmp, numattachs);
        }  
      else if (!IsEmpty (cgi->GetEntryDef ("at_show", "")))
        {
        TBuffer fntmp;
        FILE *fw;
        MakeTmpName (fntmp);
        fw = fopen (fntmp, "w");
        fprintf (fw, "%s\n", cgi->GetEntryDef ("savemsgsentmail", "0"));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("to", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("cc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("bcc", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("subject", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("texttosend", ""));
        fclose (fw);        
        sprintf (BufW, "%s %d %d %d %s %s at_show %s\n", connid, pageid, validator, lastcmd, stlang, clientip, fntmp);
        }
      else if (!IsEmpty (cgi->GetEntryDef ("cm_cleanall", "")))
        {
        sprintf (BufW, "%s %d %d %d %s %s cm_cleanall\n", connid, pageid, validator, lastcmd, stlang, clientip);        
        }                
      else if (!IsEmpty (cgi->GetEntryDef ("at_save", "")))
        {
        sprintf (BufW, "%s %d %d %d %s %s at_save %s\n", connid, pageid, validator, lastcmd, stlang, clientip, cgi->GetEntryDef ("file", ""));
        }
      else if (!IsEmpty (cgi->GetEntryDef ("at_erase", "")))
        {
        attnumbers = cgi->GetMultipleEntries ("attnumber", ",");
        sprintf (BufW, "%s %d %d %d %s %s at_erase %s\n", connid, pageid, validator, lastcmd, stlang, clientip, attnumbers);
        }
      else
        {
        sprintf (BufW, "%s %d %d %d %s %s cm\n", connid, pageid, lastcmd, validator, stlang, clientip);
        }  
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;  
    //connid validator lang cm_reply
    case CMD_CM_REPLY:
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      len = xatoldef (parm1, (long)1);            
      sprintf (BufW, "%s %d %d %d %s %s cm_reply %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;                     
    //connid validator lang cm_forward
    case CMD_CM_FORWARD: 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock); 
      len = xatoldef (parm1, (long)1);     
      sprintf (BufW, "%s %d %d %d %s %s cm_forward %ld\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;  
    //connid validator lang op
    case (CMD_OP): 
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      if (!IsEmpty (cgi->GetEntryDef ("op_cancel", "")))
        {
        sprintf (BufW, "%s %d %d %d %s %s op_cancel\n", connid, pageid, validator, lastcmd, stlang, clientip);
        }
      else if (!IsEmpty (cgi->GetEntryDef ("op_save", "")))  
        {                    
        TBuffer fntmp;
        FILE *fw;
        MakeTmpName (fntmp);
        fw = fopen (fntmp, "w");
        fprintf (fw, "%s\n", cgi->GetEntryDef ("msgsperindexpage", ""));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("insigninnewmsg", "0"));
        fprintf (fw, "%s\n", HTML2text(cgi->GetEntryDef ("personalname", "")));
        fprintf (fw, "%s\n", cgi->GetEntryDef ("savemsgsentmail", "")); //SaveMsgSentMail()
        fprintf (fw, "%s\n", cgi->GetEntryDef ("replyfrom", "")); //Reply to from
        fprintf (fw, "%s\n", cgi->GetEntryDef ("forwattachs", "")); //Include attachs in forw
        fprintf (fw, "%s\n", cgi->GetEntryDef ("heightwritearea", "")); //Size of Height of Write Area
        fprintf (fw, "%s\n", cgi->GetEntryDef ("widthwritearea", "")); //Size of Width of Write Area        
        fprintf (fw, "%s",  HTML2text(Cut (cgi->GetEntryDef ("textsignature", ""), MAXLENGTH_IN_SIGN)));
        fclose (fw);
        sprintf (BufW, "%s %d %d %d %s %s op_save %s\n", connid, pageid, validator, lastcmd, stlang, clientip, fntmp);
        }
      else
        {
        sprintf (BufW, "%s %d %d %d %s %s op\n", connid, pageid, validator, lastcmd, stlang, clientip);
        }
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;                           
   //connid validator lang ab
    case (CMD_AB): 
      {
      int subcmd;
      subcmd = TranslateCmd (stsubcmd); 
      if (!IsEmpty (cgi->GetEntryDef ("ab_saveentry", ""))) {subcmd = TranslateCmd ("ab_saveentry");}
      else if (!IsEmpty (cgi->GetEntryDef ("ab_deleentry", ""))) {subcmd = TranslateCmd ("ab_deleentry");}
      strcpy (fnsocket, make_session_socket (user, connid));
      sock = clientsocket->do_client_unix (fnsocket);
      if (sock == ERROR_SOCKET) {CGIErrorPageConnectionRefused(stlang);}
      clientsocket->SetSock (sock);
      switch (subcmd)
        {
        case CMD_AB_SAVEENTRY:
          {
          TBuffer fntmp;
          FILE *fw;
          MakeTmpName (fntmp);
          fw = fopen (fntmp, "w");
          fprintf (fw, "%s\n", HTML2text(Cut (cgi->GetEntryDef ("nickname",  ""), MAXLENGTH_FIELD_AB)));
          fprintf (fw, "%s\n", HTML2text(Cut (cgi->GetEntryDef ("fullname",  ""), MAXLENGTH_FIELD_AB)));
          fprintf (fw, "%s\n", HTML2text(Cut (cgi->GetEntryDef ("addresses", ""), MAXLENGTH_FIELD_AB)));
          fprintf (fw, "%s\n", HTML2text(Cut (cgi->GetEntryDef ("fcc", ""),       MAXLENGTH_FIELD_AB)));
          fprintf (fw, "%s\n", HTML2text(Cut (cgi->GetEntryDef ("comments",  ""), MAXLENGTH_FIELD_AB)));
          fclose (fw);
          sprintf (BufW, "%s %d %d %d %s %s ab_saveentry %s %s\n", connid, pageid, validator, lastcmd, stlang, clientip, cgi->GetEntryDef ("numentry", "-1"), fntmp);
          break;
          }                                         
        case CMD_AB_EDITENTRY:
          sprintf (BufW, "%s %d %d %d %s %s ab_editentry %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1);
          break;
        case CMD_AB_TAKEADDRESS:
          sprintf (BufW, "%s %d %d %d %s %s ab_takeaddress %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1);
          break;
        case CMD_AB_SORT:
          sprintf (BufW, "%s %d %d %d %s %s ab_sort %s\n", connid, pageid, validator, lastcmd, stlang, clientip, parm1);
          break;          
        case CMD_AB_NEWENTRY:
          sprintf (BufW, "%s %d %d %d %s %s ab_newentry\n", connid, pageid, validator, lastcmd, stlang, clientip);
          break;          
        case CMD_AB_DELEENTRY:
          sprintf (BufW, "%s %d %d %d %s %s ab_deleentry %s\n", connid, pageid, validator, lastcmd, stlang, clientip, cgi->GetEntryDef ("numentry",  "-1"));
          break;
        case CMD_AB_ADDTO:
          {
          int len = xatoidef (parm1, (int)1);        
          sprintf (BufW, "%s %d %d %d %s %s ab_addto %d\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
          break;
          }            
        case CMD_AB_ADDCC:
          {
          int len = xatoidef (parm1, (int)1);        
          sprintf (BufW, "%s %d %d %d %s %s ab_addcc %d\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
          break;
          }            
        case CMD_AB_ADDBCC:
          {
          int len = xatoidef (parm1, (int)1);        
          sprintf (BufW, "%s %d %d %d %s %s ab_addbcc %d\n", connid, pageid, validator, lastcmd, stlang, clientip, len);
          break;
          }            
        default:
          {
          sprintf (BufW, "%s %d %d %d %s %s ab_showall\n", connid, pageid, validator, lastcmd, stlang, clientip);
          break;
          }
        }    
      res = clientsocket->Puts (BufW);
      while (clientsocket->Gets (BufR, CMAXBUFFER) == true) {printf ("%s\n", BufR);}
      break;
      }           
    //DEFAULT
    default:           
      ErrorPage ("Undefined command.");
      break;
    }
  fclose (stdout);
  clientsocket->Close ();
  delete clientsocket;
  delete cgi;
  delete L;
  return 0;
  }
  
   
