/*
SendMSG.cc
*/

#include "SendMSG.h"
extern Language *L;
extern STRINGDRIVER file_string;

char *MakeBoundary (void)
  {
  char B[LENGTHBOUNDARY + 10];
  strcpy (B, "");                           
  for (int i = 0; i < LENGTHBOUNDARY; ++i)
    {
    int p = Rand (9);
    strcat (B, xitoa(p));
    }
  return xstrdup(B);
  }
  
char *MakeMidBoundary (const char *boundary)
  {
  char B[LENGTHBOUNDARY + 10];
  strcpy (B, "--"); strcat (B, boundary);
  return xstrdup (B);
  }

char *MakeEndBoundary (const char *boundary)
  {
  char B[LENGTHBOUNDARY + 10];
  strcpy (B, "--"); strcat (B, boundary); strcat (B, "--");
  return xstrdup (B);  
  }

char *MakeContentID (const char *user, const char *maildomain)
  {
  char B[LENGTHBOUNDARY + 10];
  strcpy (B, "<");
  for (int i = 0; i < 10; ++i)
    {
    int p = Rand (9);
    strcat (B, xitoa(p));
    }
  strcat (B, user); 
  strcat (B, "@");
  strcat (B, maildomain);
  strcat (B, ">");
  return xstrdup(B);    
  }

SendMSG::SendMSG (const char *asmtpserver, char *flname, UserOptions *auo, 
                  const char *adefaulthost, IMAP *aimap)
  {
  int cont, size, numlineas;
  FILE *fr;
  TBuffer linea;
  
  imap = aimap;
  uo = auo;
  localhost = xstrdup (mylocalhost ());
  user = xstrdup (auo->getUsername());
  defaulthost = xstrdup (adefaulthost);
  smtpserver = xstrdup (asmtpserver);
  to      = NULL;
  cc      = NULL;
  bcc     = NULL;
  subject = NULL;
  firsttext  = NULL;
  setPERSONALNAME (auo->getPersonalName());
  fr = fopen (flname, "r");
  fgets (linea, CMAXBUFFER, fr); QuitaRetornoCarroDeLinea (linea); 
         savemsginsentmail = xatoidef (linea, 0);
  fgets (linea, CMAXBUFFER, fr); QuitaRetornoCarroDeLinea (linea); setTO (linea);
  fgets (linea, CMAXBUFFER, fr); QuitaRetornoCarroDeLinea (linea); setCC (linea);
  fgets (linea, CMAXBUFFER, fr); QuitaRetornoCarroDeLinea (linea); setBCC (linea);
  fgets (linea, CMAXBUFFER, fr); QuitaRetornoCarroDeLinea (linea); setSUBJECT (linea);
  size = 0; cont = 0; numlineas = 0;
  while (fgets (linea, CMAXBUFFER, fr) != NULL)
    {
    ++numlineas;
    size += strlen (linea) + 1;
    firsttext = (char *) realloc (firsttext, size);
    if (cont == 0) strcpy (firsttext, linea); else strcat (firsttext, linea);
    ++cont;
    strcpy (linea, "");
    }
  fclose (fr);
  if (numlineas == 1) QuitaRetornoCarroDeLinea (firsttext);
  Quoted = IsQuotedPrintable (firsttext);
  }  
  
SendMSG::~SendMSG ()
  {
  }  

void SendMSG::setTO  (char *ato)
  {
  if (ato != NULL) to = xstrdup (ato);
  else to = NULL;  
  }

void SendMSG::setCC  (char *acc)
  {
  if (acc != NULL) cc = xstrdup (acc);
  else cc = NULL;  
  }

void SendMSG::setBCC  (char *abcc)
  {
  if (abcc != NULL) bcc = xstrdup (abcc);
  else bcc = NULL;  
  }

void SendMSG::setSUBJECT  (char *asubject)
  {
  if (asubject != NULL) subject = xstrdup (asubject);
  else subject = NULL;  
  }         
 
void SendMSG::setPERSONALNAME  (char *apersonalname)
  {
  if (apersonalname != NULL) personalname = xstrdup (apersonalname);
  else personalname = NULL;  
  }  
  
void SendMSG::setFIRSTTEXT  (char *afirsttext)
  {
  if (afirsttext != NULL) firsttext = xstrdup (afirsttext);
  else firsttext = NULL;  
  }
    
char *SendMSG::getTO (void) {return to;}
char *SendMSG::getCC (void) {return cc;} 
char *SendMSG::getBCC (void) {return bcc;}
char *SendMSG::getSUBJECT (void) {return subject;}          
char *SendMSG::getPERSONALNAME (void) {return personalname;}          
char *SendMSG::getFIRSTTEXT (void) {return firsttext;}    

void SendMSG::DelAttachs (void)
  {
  uo->delAllAttachs();
  //DelAllFilesFromDir ((char *)uo->getAttachDir());
  }
        
void SendMSG::ExtraeAddresses (StringList *SL, char *linea)
  {
  int menor, mayor;
  char c, letra[2];
  XString Ad;
  letra[1] = '\0';
  SL->Clear();
  Ad = XString("");
  for (int i = 0; i < (xsint)strlen(linea); ++i)
    {
    c = linea[i]; 
    letra[0] = c;
    switch (c)
      {
      case ',': 
           if (Ad.length() > 0) 
             {
             menor = Ad.indexOf ('<'); mayor = Ad.indexOf ('>');
             if ((menor >= 0) && (mayor >= 0)) {SL->Add(Ad.substring(menor, mayor + 1));}
             else SL->Add(Ad);
             Ad = XString("");        
             }
           break;
      default:
           Ad += letra;
           break;
      }
    }
  if (Ad.length() > 0) 
    {
    menor = Ad.indexOf ('<'); mayor = Ad.indexOf ('>');
    if ((menor >= 0) && (mayor >= 0)) {SL->Add(Ad.substring(menor, mayor + 1));}
    else SL->Add(Ad);
    Ad = XString("");            
    }
  }
         
bool SendMSG::sendSMTP  (TBuffer errormsg)
  {
  strcpy (errormsg, "");  
  if (IsEmpty (to))     {strcpy (errormsg, L->get(MSG_FIELD_TO_EMPTY)); return false;}
  if (IsEmpty(subject)) {strcpy (errormsg, L->get(MSG_FIELD_SUBJ_EMPTY)); return false;}
  /*
  HELO <MIHOSTNAME>
  MAIL FROM: <SENDER>
  RCPT TO: <RECIPIENT>
  DATA
  ......
  .
  QUIT
  */
  int cod;
  char buffer[1024], basura[1024], MailDomain[50];
  XSocket *smtpsocket;
  int sock;
  bool HAYADJUNTOS = false;

  strcpy (MailDomain, uo->getMailDomain());
  smtpsocket = new XSocket ();
  smtpsocket->ignore_pipe();
  sock = smtpsocket->do_client_inet (smtpserver, NULL, DEFSMTPPORT);
  if (sock == -1) return false;
  smtpsocket->SetSock (sock);
  /*LEO LA LINEA DE BIENVENIDA*/
  /*-1 by the possible buffer overflow resulting from the linefeed added below. */
  if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;}
  sscanf (buffer, "%d %s", &cod, basura);
  if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}

  /*ENVIO HELO*/
  sprintf (buffer, "HELO %s\n", localhost);
  if (smtpsocket->Puts (buffer) == -1) {return false;}
  /*LEO LA LINEA DE HELO*/
  if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;} 
  sscanf (buffer, "%d %s", &cod, basura);
  if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}
  
  /*ENVIO MAIL FROM*/
  sprintf (buffer, "MAIL FROM: %s@%s\n", user, MailDomain);
  if (smtpsocket->Puts (buffer) == -1) {return false;}
  /*LEO LA LINEA DE MAIL FROM*/
  if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;} 
  sscanf (buffer, "%d %s", &cod, basura);
  if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}
  
  /*ENVIO RCPT*/
  ExtraeAddresses (&SLTO,  to);
  ExtraeAddresses (&SLCC,  cc);
  ExtraeAddresses (&SLBCC, bcc);
  for (int k = 0; k < SLTO.Count(); ++k)
    {
    sprintf (buffer, "RCPT TO: %s\n", SLTO.getString(k).cstr());
    if (smtpsocket->Puts (buffer) == -1) {return false;}
    /*LEO LA LINEA DE RCPT*/
    if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;} 
    sscanf (buffer, "%d %s", &cod, basura);
    if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}
    }
  for (int h = 0; h < SLCC.Count(); ++h)
    {
    sprintf (buffer, "RCPT TO: %s\n", SLCC.getString(h).cstr());
    if (smtpsocket->Puts (buffer) == -1) {return false;}
    /*LEO LA LINEA DE RCPT*/
    if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;} 
    sscanf (buffer, "%d %s", &cod, basura);
    if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}
    }    
  for (int m = 0; m < SLBCC.Count(); ++m)
    {
    sprintf (buffer, "RCPT TO: %s\n", SLBCC.getString(m).cstr());
    if (smtpsocket->Puts (buffer) == -1) {return false;}
    /*LEO LA LINEA DE RCPT*/
    if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;} 
    sscanf (buffer, "%d %s", &cod, basura);
    if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}
    }    
          
  /*ENVIO DATA*/
  sprintf (buffer, "DATA\n");
  if (smtpsocket->Puts (buffer) == -1) {return false;}
  /*LEO LA LINEA DE DATA*/
  if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {return false;} 
  sscanf (buffer, "%d %s", &cod, basura);
  if ((cod < 200) || (cod > 400)) {strncpy (errormsg, buffer, CMAXBUFFER); return false;}
  
  /*METO MIS DATOS*/
  LINEA BOUNDARY, MIDBOUNDARY, ENDBOUNDARY;
  strcpy (BOUNDARY, MakeBoundary ());
  strcpy (MIDBOUNDARY, MakeMidBoundary (BOUNDARY));
  strcpy (ENDBOUNDARY, MakeEndBoundary (BOUNDARY));
      
  char *fntmp;
  fntmp = xstrdup (MakeTmpName (NULL));  

  FILE *FW;
  FW = fopen (fntmp, "w");
  
  XString XS;
  if (IsEmpty (personalname)) {XS = XString("<"); XS += user;}
  else {XS = XString("\""); XS += personalname; XS += "\"<"; XS += user;}
  if (!IsEmpty (MailDomain)) {XS += "@"; XS += MailDomain;}
  XS += ">";
  fprintf (FW, "From: %s\n", (char *)CodificaHeaderQuotedP_One2One((xuchar *)XS.cstr()));
  fprintf (FW, "To: %s\n", to);
  if (IsEmpty(cc) == false)      
    {fprintf (FW, "Cc: %s\n", (char *)CodificaHeaderQuotedP_One2One((xuchar *)cc));}
  if (IsEmpty(bcc) == false)     
    {fprintf (FW, "Bcc: %s\n", (char *)CodificaHeaderQuotedP_One2One((xuchar *)bcc));}    
  if (IsEmpty(subject) == false) 
    {fprintf (FW, "Subject: %s\n", (char *)CodificaHeaderQuotedP_One2One((xuchar *)subject));}
  
  //Date: Mon, 8 Sep 1997 15:06:16 +0200 (METDST)
  time_t now; now = time (NULL);
  fprintf (FW, "Date: %s", ctime(&now));    
  fprintf (FW, "X-Mailer: %s\n", XMAILER);
  fprintf (FW, "Message-ID: %s\n", MakeContentID (user, MailDomain));
  fprintf (FW, "MIME-Version: 1.0\n");
  if (uo->numAttachs() > 0)  
    {
    HAYADJUNTOS = true;
    fprintf (FW, "Content-Type: Multipart/Mixed; BOUNDARY=\"%s\"\n", BOUNDARY);
    fprintf (FW, "\n");
    }
  else
    {  
    HAYADJUNTOS = false;
    fprintf (FW, "Content-Type: TEXT/PLAIN; charset=%s\n", THECHARSET);
    if (Quoted == true) fprintf (FW, "Content-Transfer-Encoding: quoted-printable\n");
    fprintf (FW, "\n");
    }
  
  if (HAYADJUNTOS == true)
    {
    fprintf (FW, "  This message is in MIME format.  The first part should be readable text,\n");
    fprintf (FW, "  while the remaining parts are likely unreadable without MIME-aware tools.\n"); 
    fprintf (FW, "\n");
    }
  
  char *fntmpquoted;
  fntmpquoted = ToQuotedPrintableFile (firsttext);
  LINEA linea;
  FILE *FR;
  if (HAYADJUNTOS == false)
    {
    FR = fopen (fntmpquoted, "r");
    strcpy (linea, "");
    while (fgets (linea, MAXLENGTHLINE, FR) != NULL)
      {
      if (strcmp (linea, "") != 0) fprintf (FW, "%s", linea);      
      strcpy (linea, "");
      }
    fclose (FR);
    DeleteFile (fntmpquoted);
    }
  else
    { 
    fprintf (FW, "\n%s\n", MIDBOUNDARY);
    fprintf (FW, "Content-Type: TEXT/PLAIN; charset=%s\n", THECHARSET);
    if (Quoted == true) fprintf (FW, "Content-Transfer-Encoding: quoted-printable\n");
    fprintf (FW, "\n");
    FR = fopen (fntmpquoted, "r");
    do {fgets (linea, MAXLENGTHLINE, FR); fprintf (FW, "%s", linea);} while (!feof(FR));      
    fclose (FR); 
    DeleteFile (fntmpquoted);   
    int i;
    i = 0;       
    while ((i < uo->numAttachs()) && (i < MAXNUMATTACHSINSEND))
      {
      //ESCRIBO EL PRIMER ADJUNTO
      LINEA truefn, CT;
      strncpy (truefn, uo->getTrueFileNameAttach(i), MAXLENGTHLINE);
      if (FileExists (truefn) == true)
        {
        strcpy (CT, getMailcapTipoFromFilename (truefn));
        if (strcmp (CT, "") == 0) 
          {
          TSBuffer basura;
          sscanf (uo->getAttachInfo(i), "%s %s", CT, basura);
          if ((strcmp (CT, "") == 0) || (strcmp (CT, "\"\",") == 0))
            {
            strcpy (CT, "APPLICATION/OCTET-STREAM");
            }
          }
        fprintf (FW, "\n%s\n", MIDBOUNDARY);
        fprintf (FW, "Content-ID: %s\n", MakeContentID (user, MailDomain));
        fprintf (FW, "Content-Type: %s; name=%s\n", CT, uo->getFileNameAttach(i));
        //NON CODED MESSAGE/RFC822
        bool IsMessageRFC822;
        IsMessageRFC822 = false;
        if (strstr (CT, "MESSAGE/RFC822") != NULL) IsMessageRFC822 = true;
        if (IsMessageRFC822 == false) fprintf (FW, "Content-Transfer-Encoding: BASE64\n");
        fprintf (FW, "\n");
        int szfn = FileSize (truefn);
        if (IsMessageRFC822 == false)
          { 
          FR = fopen (truefn, "r");
          EncodeBase64File (FR, FW, szfn);
          fclose (FR);
          }
        else
          {
          FR = fopen (truefn, "r");
          strcpy (linea, "");
          while (fgets (linea, MAXLENGTHLINE, FR) != NULL)
            {
            if (strcmp (linea, "") != 0) fprintf (FW, "%s", linea);      
            strcpy (linea, "");
            }
          fclose (FR);
          }
        }
      ++i;
      }
    fprintf (FW, "\n%s\n", ENDBOUNDARY);
    }  
  fclose (FW);  
  
  //GUARDO PRIMERO EN LA CARPETA SENTMAIL
  if ((savemsginsentmail) && (imap != NULL)) 
    {
    bool bo;
    STRING stmsg;
    int sz;
    sz = FileSize (fntmp);
    FR = fopen (fntmp, "r");
    INIT (&stmsg, file_string, (void *)FR, sz);
    bo = imap->appendMsg (DEFSENTMAILBOX, &stmsg);
    if (!bo)
      {
      bo = imap->createMailbox (DEFSENTMAILBOX);
      if (bo) 
        {
        INIT (&stmsg, file_string, (void *)FR, sz);
        bool bx;
        bx = imap->appendMsg(DEFSENTMAILBOX, &stmsg);
        if (bx == false)
          {
          strcpy (errormsg, "Can not save msg in sent mail");
          }
        }
      else
        {
        strcpy (errormsg, "Can not save msg in sent mail");
        }  
      }
    fclose (FR); 
    }

  //ENVIO YA EL FICHERO POR SMTP
  FR = fopen (fntmp, "r");
  strcpy (linea, "");
  while (fgets (linea, MAXLENGTHLINE, FR) != NULL)
    {
    if (strcmp (linea, "") != 0) 
      {
      if (strcmp (linea, ".\n") == 0) {strcpy (linea, " .\n");}
      if (strcmp (linea, ".\015\012") == 0) {strcpy (linea, " .\n");}        
      if (smtpsocket->Puts (linea) == -1) {fclose (FR); DeleteFile (fntmp); return false;}    
      }
    strcpy (linea, "");
    }
  fclose (FR);
  
  sprintf (buffer, "\n.\n");
  if (smtpsocket->Puts (buffer) == -1) {fclose (FR); DeleteFile (fntmp); return false;}
  
  /*LEO LA LINEA DE ACEPTACION DE DATOS*/
  if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {fclose (FR); DeleteFile (fntmp); return false;}
  sscanf (buffer, "%d %s", &cod, basura);
  if ((cod < 200) || (cod > 400)) {fclose (FR); DeleteFile (fntmp); return false;}
  
  /*ENVIO QUIT*/
  sprintf (buffer, "QUIT\n");
  if (smtpsocket->Puts (buffer) == -1) {fclose (FR); DeleteFile (fntmp); return false;}
  /*LEO LA LINEA DE QUIT*/
  if (!smtpsocket->Gets (buffer, sizeof(buffer) -1)) {fclose (FR); DeleteFile (fntmp); return false;}
  sscanf (buffer, "%d %s", &cod, basura);
  if ((cod < 200) || (cod > 400)) {fclose (FR); DeleteFile (fntmp); return false;}
  
  DeleteFile (fntmp);
  delete smtpsocket;
  return true;
  }        
        
  
      
