/*
UserOptions.h
*/

#ifndef __USEROPTIONS_H
#define __USEROPTIONS_H

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>

#include "Utils.h"
#include "Config.h"
#include "XString.h"
#include "XVector.h"

typedef XVector<XString> StringList;

class UserOptions
  {
  private:
    TBuffer StatusLine;
    XString user, basepath, userdir, userattdir, fnuseroptions, fnsignature, fnsavedmsg;
    bool InsertSignatureInNewMsg, SaveMsgSentMail, ForwAttachs, ReplyFrom;
    long MsgsPerIndexPage, CurrentPosition, TotalMsgs, MAILBOXSIZE, BeginPage;
    XString personalname, signature;
    int validator, pageid, lastcmd, sort_ab, WidthWriteArea, HeightWriteArea;
    StringList SLAttachList, SLAttachListInfo, PilaCmds;
    char MAILDOMAIN[50], IMAPSERVER[50], SMTPSERVER[50];
  public:
    UserOptions (const char *abasepath, const char *auser);
    virtual ~UserOptions (); 
    void InitStatusLine (void);
    const char *getStatusLine (void);
    void setStatusLine (char *newstatusline, char *htmlcolor);
    int getValidator (void);
    void IncValidator (void);
    void setCurrentPosition (long pos, long total);
    long getCurrentPosition (void);
    long getBeginPage (void);    
    void setMailboxSize (long asize);
    long getMailboxSize (void);    
    long getTotalMsgs (void);
    void setInsertSignatureInNewMsg (bool value);
    bool getInsertSignatureInNewMsg (void); 
    void setMailDomain (const char *amaildomain);
    char *getMailDomain (void);
    void setImapServer (const char *aimapserver);
    char *getImapServer (void);    
    void setSMTPServer (const char *asmtpserver);
    char *getSMTPServer (void);        
    const char *getUsername (void);
    const char *getAttachDir (void);    
    void setMsgsPerIndexPage (long value);
    long getMsgsPerIndexPage (void);
    void setPersonalName (char *value);
    char *getPersonalName (void);
    bool getSaveMsgSentMail (void);
    void setSaveMsgSentMail (bool value);
    void setReplyFrom (bool value);
    bool getReplyFrom (void);
    void setForwAttachs (bool value);
    bool getForwAttachs (void);
    void setWidthWriteArea (int value);
    int  getWidthWriteArea (void);    
    void setHeightWriteArea (int value);
    int  getHeightWriteArea (void);            
    char *getSignature (void);
    bool SaveOptions (char *tmpfilename);
    void LoadOptions (void);
    int numAttachs (void);
    char *getFileNameAttach (int p);
    char *getTrueFileNameAttach (int p);
    char *getAttachInfo (int p);
    int addFileNameAtach (char *newfile, char *info);
    int delFileNameAtach (char *attachnumbers);
    void delAllAttachs (void);
    void setSort_ab (int value);
    int getSort_ab (void);    
    char *getfnSavedMsg (void);
    void setLastCmd (int value);
    int getLastCmd (void);        
    void vuelcaPila (void);
    void setPageId (int value);
    int getPageId (void);    
    char *getLastStringCmd (int cmdactual, char *lang, char *connid, bool withhtml);    
    void addLastStringCmd (char *stcmd);
  };
  
#endif

