/* 
rutinas_db.c
*/

#include "rutinas_db.h"   

struct passwd *sm_getpwnam (char *dbfile, char *user)
{
        DB *dbusus;
        DBT dkey, od;
        int status, i;
        static char dato[MAXDATUM];
        static struct passwd usupw;
        static char nomusu[MAXUSUNOM],*vacio="";
        char *p, *pcam[MAXCAM];
        
        if (isdebug) syslog(XLOGPRIORITY, "dbusu_note: %s",user); 

        dbusus = dbopen (dbfile, O_RDONLY, 0444, DB_HASH, NULL);
        if (dbusus == NULL) 
          {
          if (isdebug) syslog(XLOGPRIORITY, "dbusu_open: %s",strerror(errno)); 
          goto normalusu;
          }
            
        dkey.data=user; dkey.size=strlen(user);
        status = dbusus->get (dbusus, &dkey, &od, 0);
        if ( status<0 ) {
          if (isdebug) 
            syslog(XLOGPRIORITY, "dbusu_get, can't read: %s",strerror(errno)); 
          } 
        else 
          if ( status==1 ) {
            if (isdebug) 
              syslog(XLOGPRIORITY, "dbusu_get, not such user: %s",user); 
            }
        else {
        
          if ( od.size>=MAXDATUM ) od.size=MAXDATUM-1; 
          if ( od.data==NULL ) od.size=0; 
          strncpy(dato,od.data,od.size);  dato[od.size]='\0';

          if (dkey.size >=MAXUSUNOM) dkey.size=MAXUSUNOM;
          strncpy(nomusu,dkey.data,dkey.size);
          
          /* Vamos buscando los ':', apuntandonos su lugar y sustituyendolos
             por nulos para terminar los str. Inicializamos a vacio por 
             si acaso */
          for (i=0; i<MAXCAM; i++) pcam[i]=vacio;
          for (p=dato,i=0; p!=NULL; p=strchr(p,':')) {
            if (p!=dato) { *p='\0'; p++; }
            if (i<MAXCAM) { pcam[i]=p; ++i; }
            }
          usupw.pw_name=nomusu;
          usupw.pw_passwd=pcam[0]; 
          usupw.pw_uid=atoi(pcam[1]); if(usupw.pw_uid == 0) {
            if (isdebug) syslog(XLOGPRIORITY, "dbusu_uid=0");
            goto normalusu;
            }
          usupw.pw_gid=atoi(pcam[2]); if(usupw.pw_gid == 0) {
            if (isdebug) syslog(XLOGPRIORITY, "dbusu_gid=0");
            goto normalusu;
            }
          usupw.pw_gecos=pcam[3];
          usupw.pw_dir=pcam[4];
          usupw.pw_shell=pcam[5];

#if defined (HP)          
          usupw.pw_age=vacio;
          usupw.pw_comment=vacio;
          usupw.pw_audid=1000;  
          usupw.pw_audflg=1;    
#endif 
 
          /* ##### AQUI VIENE EL CAMBIO DE PRIMER DIRECTORIO #### */
          {
            static char directorio_www[MAXDATUM], *usuhom;
            strcpy(directorio_www,"/tela"); 
            usuhom=usupw.pw_dir; 
            /* Busca la segunda "/" */
            if (*usuhom=='/') 
              for (usuhom++ ;*usuhom!='\0' && *usuhom!='/';++usuhom);
            strcat(directorio_www,usuhom); 
            strcat(directorio_www,"\n");  /* NECESARIO para ESTE programa*/
            usupw.pw_dir=directorio_www;
          }
          /* ##### FIN DEL CAMBIO DE DIRECTORIO /gente -> /tela #### */

          
          }
        if ( dbusus->close(dbusus) != 0) if (isdebug) syslog(XLOGPRIORITY, "dbusu_close: %d",errno);
        if (status==0) return &usupw;
        return NULL;
normalusu:        
        if (isdebug) syslog(XLOGPRIORITY, "dbusu_normalusu: %s",user); 
        return getpwnam(user);
}           

int verify_user_POST (char *user, char *pass)
  {
  char *cp, p2[3];
#if defined (HP)
  struct pr_passwd *pwd;
  pwd = getprpwnam (user);
  if (pwd == NULL) return (0);
  cp = crypt (pass, pwd->ufld.fd_encrypt);
  if (strcmp(cp, pwd->ufld.fd_encrypt) == 0) 
    {
    /*PW CORRECTA*/
    return (1);
    }
  else 
    {
    /*MALA PW*/
    return (0);
    }
#elif defined (LINUX)
  struct passwd *pwd;
  pwd = getpwnam (user);
  if (pwd == NULL) return (0);
  p2[0] = pwd->pw_passwd[0]; p2[1] = pwd->pw_passwd[1]; p2[2] = '\0';
  cp = crypt (pass, p2);
  if (strcmp(cp, pwd->pw_passwd) == 0) 
    {
    /*PW CORRECTA*/
    return (1);
    }
  else 
    {
    /*MALA PW*/
    return (0);
    }
#endif
  }

int verify_user_POSTAL (char *dbfile, char *user, char *pass)
  {
  struct passwd *pw;
  char *cp, p2[3];
  pw = sm_getpwnam(dbfile, user);
  if (pw == NULL) return (0); 
  else
    {
    p2[0] = pw->pw_passwd[0]; p2[1] = pw->pw_passwd[1]; p2[2] = '\0'; 
    cp = crypt(pass, p2);
    if (strcmp (cp, pw->pw_passwd) == 0) return (1);   /*PW CORRECTA*/
    else return (0);                                   /*MALA PW*/
    }
  }

int exist_user_POSTAL (char *dbfile, char *user)
  {
  struct passwd *pw;
  pw = sm_getpwnam (dbfile, user);
  if (pw == NULL) return (0); else return (1);
  }
  
int exist_user (char *dbfile, char *user)
  {
  struct passwd *pw;
  pw = sm_getpwnam (dbfile, user);
  if (pw == NULL) return (0); else return (1);
  }

void db_get_server_port_from_user (char *dbfile, char *user, char *server, int *port)
  {
  DB *dbusus;
  DBT dkey, od;
  int status,i;
  static char dato[MAXDATUM];
  static char nomusu[MAXUSUNOM], *vacio="";
  char *p, *pcam[MAXCAM];
  
  server[0] = '\0';
  dbusus = dbopen (dbfile, O_RDONLY, 0444, DB_HASH, NULL);
  if ( dbusus == NULL ) 
    {
    server[0] = '\0';
    return;
    }
  dkey.data= user; dkey.size= strlen(user);
  status = dbusus->get (dbusus, &dkey, &od, 0);
  if ( status<0 ) 
    {
    if (isdebug) syslog(XLOGPRIORITY, "dbusu_get, can't read: %s",strerror(errno)); 
    server[0] = '\0';
    return;
    } 
  else
    { 
    if (status==1) 
      {
      server[0] = '\0';
      return;
      }
    else 
      {
      if ( od.size>=MAXDATUM ) od.size=MAXDATUM-1; 
      if ( od.data==NULL ) od.size=0; 
      strncpy(dato,od.data,od.size);  dato[od.size]='\0';

      if (dkey.size >=MAXUSUNOM) dkey.size=MAXUSUNOM;
      strncpy (nomusu, dkey.data, dkey.size);
    
      /* Vamos buscando los ':', apuntandonos su lugar y sustituyendolos
         por nulos para terminar los str. Inicializamos a vacio por si acaso */
      for (i=0; i<MAXCAM; i++) pcam[i]=vacio;
      for (p=dato,i=0; p!=NULL; p=strchr(p,':')) 
        {
        if (p!=dato) { *p='\0'; p++; }
        if (i<MAXCAM) { pcam[i]=p; ++i; }
        }
      strncpy (server, pcam[0], 49);
      if (pcam[1] != NULL)
        {
        if (strcmp (pcam[1], vacio) != 0)
          {
          *port = atoi (pcam[1]);
          if (*port == 0) {*port = -1;}
          }
        }
      }
    if ( dbusus->close(dbusus) != 0) if (isdebug) syslog(XLOGPRIORITY, "dbusu_close: %d",errno);
    }
  }
  
  
